View Issue Details

IDProjectCategoryView StatusLast Update
0000402bareos-core[All Projects] directorpublic2019-01-16 11:05
ReporterjbehrendAssigned Toarogge 
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionno change required 
PlatformLinuxOSDebianOS Version8
Product Version14.2.2 
Target VersionFixed in Version 
Summary0000402: MaximumConcurrentJobs and AllowMixedPriority
DescriptionLower prio jobs do not start if higher prio job is running although AllowMixedPriority is configured. Once the high prio job is done the others start correctly even if there is another high prio job scheduled. It seemd the scheduler only honors priorities in "context switches", i.e. when a job finishes or starts.
Steps To ReproduceStart a Restore with prio 9 and wait for nightly schedule to start jobs with prio 40 and get:

*s dir

Running Jobs:
Console connected at 21-Jan-15 08:39
 JobId Level Name Status
======================================================================
114298 Restore.2015-01-19_10.24.53_04 is running
114300 Increme fsef.2015-01-20_00.06.00_07 is waiting for higher priority jobs to finish
114301 Increme fsme.2015-01-20_00.06.00_08 is waiting execution
114302 Increme fsme1.2015-01-20_00.06.01_09 is waiting execution
114303 Increme fsother.2015-01-20_00.06.01_10 is waiting execution
114304 Increme fsre.2015-01-20_00.06.01_11 is waiting execution
114305 Increme fsrz.2015-01-20_00.06.01_12 is waiting execution
114306 Increme fswe.2015-01-20_00.06.01_13 is waiting execution
114307 Increme fsze.2015-01-20_00.06.01_14 is waiting execution
114308 Increme alma-heuristics.2015-01-20_00.07.00_15 is waiting execution
114309 Increme archivesrv1.2015-01-20_00.07.00_16 is waiting execution
114310 Increme archivesrv2.2015-01-20_00.07.00_17 is waiting execution
114311 Increme atlasgal.2015-01-20_00.07.00_18 is waiting execution
114312 Increme auxeff.2015-01-20_00.07.00_19 is waiting execution
114313 Increme debinstall.2015-01-20_00.07.00_20 is waiting execution
114314 Increme efflog.2015-01-20_00.07.00_21 is waiting execution
114315 Increme effntp1.2015-01-20_00.07.00_22 is waiting execution
114316 Increme effntp2.2015-01-20_00.07.00_23 is waiting execution
114317 Increme effshare.2015-01-20_00.07.00_24 is waiting execution
114318 Increme elshare.2015-01-20_00.07.00_25 is waiting execution
114319 Increme fsef-mgt.2015-01-20_00.07.00_26 is waiting execution
114320 Increme fsef2-mgt.2015-01-20_00.07.00_27 is waiting execution
114321 Increme fsme-mgt.2015-01-20_00.07.00_28 is waiting execution
114322 Increme fsme1-mgt.2015-01-20_00.07.00_29 is waiting execution
114323 Increme fsme12-mgt.2015-01-20_00.07.00_30 is waiting execution
114324 Increme fsme2-mgt.2015-01-20_00.07.00_31 is waiting execution
114325 Increme fsother-mgt.2015-01-20_00.07.00_32 is waiting execution
114326 Increme fsother2-mgt.2015-01-20_00.07.00_33 is waiting execution
114327 Increme fsre-mgt.2015-01-20_00.07.00_34 is waiting execution
114328 Increme fsre2-mgt.2015-01-20_00.07.00_35 is waiting execution
114329 Increme fsrz-mgt.2015-01-20_00.07.00_36 is waiting execution
114330 Increme fsrz2-mgt.2015-01-20_00.07.00_37 is waiting execution
114331 Increme fswe-mgt.2015-01-20_00.07.00_38 is waiting execution
114332 Increme fswe2-mgt.2015-01-20_00.07.00_39 is waiting execution
114333 Increme fsze-mgt.2015-01-20_00.07.00_40 is waiting execution
114334 Increme fsze2-mgt.2015-01-20_00.07.00_41 is waiting execution
114335 Increme geosrv.2015-01-20_00.07.00_42 is waiting execution
114336 Increme gltfw.2015-01-20_00.07.00_43 is waiting execution
114337 Increme lcfs.2015-01-20_00.07.00_44 is waiting execution
114338 Increme log.2015-01-20_00.07.00_45 is waiting execution
114339 Increme mailbox1.2015-01-20_00.07.00_46 is waiting execution
114340 Increme mailbox2.2015-01-20_00.07.00_47 is waiting execution
114341 Increme mcn7.2015-01-20_00.07.00_48 is waiting execution
114342 Increme mcn8.2015-01-20_00.07.00_49 is waiting execution
114343 Increme miraculix.2015-01-20_00.07.00_50 is waiting execution
114344 Increme mmshare.2015-01-20_00.07.00_51 is waiting execution
114345 Increme nagios.2015-01-20_00.07.00_52 is waiting execution
114346 Increme ntp1.2015-01-20_00.07.00_53 is waiting execution
114347 Increme ntp2.2015-01-20_00.07.00_54 is waiting execution
114348 Increme numerix.2015-01-20_00.07.00_55 is waiting execution
114349 Increme observer3.2015-01-20_00.07.00_56 is waiting execution
114350 Increme observer4.2015-01-20_00.07.00_57 is waiting execution
114351 Increme observer6.2015-01-20_00.07.00_58 is waiting execution
114352 Increme owncloud.2015-01-20_00.07.00_59 is waiting execution
114353 Increme portal.2015-01-20_00.07.01_00 is waiting execution
114354 Increme portal2.2015-01-20_00.07.01_01 is waiting execution
114355 Increme project.2015-01-20_00.07.01_02 is waiting execution
114356 Increme psrfb7.2015-01-20_00.07.01_03 is waiting execution
114357 Increme publications.2015-01-20_00.07.01_04 is waiting execution
114358 Increme quasar.2015-01-20_00.07.01_05 is waiting execution
114359 Increme scishare.2015-01-20_00.07.01_06 is waiting execution
114360 Increme snort.2015-01-20_00.07.01_07 is waiting execution
114361 Increme snort2.2015-01-20_00.07.01_08 is waiting execution
114362 Increme swsrv1-mgt.2015-01-20_00.07.01_09 is waiting execution
114363 Increme swsrv1.2015-01-20_00.07.01_10 is waiting execution
114364 Increme swsrv12-mgt.2015-01-20_00.07.01_11 is waiting execution
114365 Increme tserver.2015-01-20_00.07.01_12 is waiting execution
114366 Increme vwshare.2015-01-20_00.07.01_13 is waiting execution
114367 Increme webdav.2015-01-20_00.07.01_14 is waiting execution
114368 Full BackupCatalog.2015-01-20_00.15.00_15 is waiting execution
114369 Increme backupsrv1.2015-01-20_00.15.00_16 is waiting execution
114370 SendDailyReport.2015-01-20_00.35.00_17 is waiting execution
114371 Increme fsef.2015-01-21_00.06.00_22 is waiting execution
114372 Increme fsme.2015-01-21_00.06.00_23 is waiting execution
114373 Increme fsme1.2015-01-21_00.06.00_24 is waiting execution
114374 Increme fsother.2015-01-21_00.06.00_25 is waiting execution
114375 Increme fsre.2015-01-21_00.06.00_26 is waiting execution
114376 Increme fsrz.2015-01-21_00.06.00_27 is waiting execution
114377 Increme fswe.2015-01-21_00.06.00_28 is waiting execution
114378 Increme fsze.2015-01-21_00.06.00_29 is waiting execution
114379 Increme alma-heuristics.2015-01-21_00.07.00_30 is waiting execution
114380 Increme archivesrv1.2015-01-21_00.07.01_31 is waiting execution
114381 Increme archivesrv2.2015-01-21_00.07.01_32 is waiting execution
114382 Increme atlasgal.2015-01-21_00.07.01_33 is waiting execution
114383 Increme auxeff.2015-01-21_00.07.01_34 is waiting execution
114384 Increme debinstall.2015-01-21_00.07.01_35 is waiting execution
114385 Increme efflog.2015-01-21_00.07.01_36 is waiting execution
114386 Increme effntp1.2015-01-21_00.07.01_37 is waiting execution
114387 Increme effntp2.2015-01-21_00.07.01_38 is waiting execution
114388 Increme effshare.2015-01-21_00.07.01_39 is waiting execution
114389 Increme elshare.2015-01-21_00.07.01_40 is waiting execution
114390 Increme fsef-mgt.2015-01-21_00.07.01_41 is waiting execution
114391 Increme fsef2-mgt.2015-01-21_00.07.01_42 is waiting execution
114392 Increme fsme-mgt.2015-01-21_00.07.01_43 is waiting execution
114393 Increme fsme1-mgt.2015-01-21_00.07.01_44 is waiting execution
114394 Increme fsme12-mgt.2015-01-21_00.07.01_45 is waiting execution
114395 Increme fsme2-mgt.2015-01-21_00.07.01_46 is waiting execution
114396 Increme fsother-mgt.2015-01-21_00.07.01_47 is waiting execution
114397 Increme fsother2-mgt.2015-01-21_00.07.01_48 is waiting execution
114398 Increme fsre-mgt.2015-01-21_00.07.01_49 is waiting execution
114399 Increme fsre2-mgt.2015-01-21_00.07.01_50 is waiting execution
114400 Increme fsrz-mgt.2015-01-21_00.07.01_51 is waiting execution
114401 Increme fsrz2-mgt.2015-01-21_00.07.01_52 is waiting execution
114402 Increme fswe-mgt.2015-01-21_00.07.01_53 is waiting execution
114403 Increme fswe2-mgt.2015-01-21_00.07.01_54 is waiting execution
114404 Increme fsze-mgt.2015-01-21_00.07.01_55 is waiting execution
114405 Increme fsze2-mgt.2015-01-21_00.07.01_56 is waiting execution
114406 Increme geosrv.2015-01-21_00.07.01_57 is waiting execution
114407 Increme gltfw.2015-01-21_00.07.01_58 is waiting execution
114408 Increme lcfs.2015-01-21_00.07.01_59 is waiting execution
114409 Increme log.2015-01-21_00.07.02_00 is waiting execution
114410 Increme mailbox1.2015-01-21_00.07.02_01 is waiting execution
114411 Increme mailbox2.2015-01-21_00.07.02_02 is waiting execution
114412 Increme mcn7.2015-01-21_00.07.02_03 is waiting execution
114413 Increme mcn8.2015-01-21_00.07.02_04 is waiting execution
114414 Increme miraculix.2015-01-21_00.07.02_05 is waiting execution
114415 Increme mmshare.2015-01-21_00.07.02_06 is waiting execution
114416 Increme nagios.2015-01-21_00.07.02_07 is waiting execution
114417 Increme ntp1.2015-01-21_00.07.02_08 is waiting execution
114418 Increme ntp2.2015-01-21_00.07.02_09 is waiting execution
114419 Increme numerix.2015-01-21_00.07.02_10 is waiting execution
114420 Increme observer3.2015-01-21_00.07.02_11 is waiting execution
114421 Increme observer4.2015-01-21_00.07.02_12 is waiting execution
114422 Increme observer6.2015-01-21_00.07.02_13 is waiting execution
114423 Increme owncloud.2015-01-21_00.07.02_14 is waiting execution
114424 Increme portal.2015-01-21_00.07.02_15 is waiting execution
114425 Increme portal2.2015-01-21_00.07.02_16 is waiting execution
114426 Increme project.2015-01-21_00.07.02_17 is waiting execution
114427 Increme psrfb7.2015-01-21_00.07.02_18 is waiting execution
114428 Increme publications.2015-01-21_00.07.02_19 is waiting execution
114429 Increme quasar.2015-01-21_00.07.02_20 is waiting execution
114430 Increme scishare.2015-01-21_00.07.02_21 is waiting execution
114431 Increme snort.2015-01-21_00.07.02_22 is waiting execution
114432 Increme snort2.2015-01-21_00.07.02_23 is waiting execution
114433 Increme swsrv1-mgt.2015-01-21_00.07.02_24 is waiting execution
114434 Increme swsrv1.2015-01-21_00.07.02_25 is waiting execution
114435 Increme swsrv12-mgt.2015-01-21_00.07.02_26 is waiting execution
114436 Increme tserver.2015-01-21_00.07.02_27 is waiting execution
114437 Increme vwshare.2015-01-21_00.07.02_28 is waiting execution
114438 Increme webdav.2015-01-21_00.07.02_29 is waiting execution
114439 Full BackupCatalog.2015-01-21_00.15.00_30 is waiting execution
114440 Increme backupsrv1.2015-01-21_00.15.00_31 is waiting execution
114441 SendDailyReport.2015-01-21_00.35.00_32 is waiting execution
114442 Increme fsef.2015-01-22_00.06.00_36 is waiting execution
114443 Increme fsme.2015-01-22_00.06.00_37 is waiting execution
114444 Increme fsme1.2015-01-22_00.06.00_38 is waiting execution
114445 Increme fsother.2015-01-22_00.06.00_39 is waiting execution
114446 Increme fsre.2015-01-22_00.06.00_40 is waiting execution
114447 Increme fsrz.2015-01-22_00.06.00_41 is waiting execution
114448 Increme fswe.2015-01-22_00.06.00_42 is waiting execution
114449 Increme fsze.2015-01-22_00.06.00_43 is waiting execution
114450 Increme alma-heuristics.2015-01-22_00.07.00_44 is waiting execution
114451 Increme archivesrv1.2015-01-22_00.07.00_45 is waiting execution
114452 Increme archivesrv2.2015-01-22_00.07.00_46 is waiting execution
114453 Increme atlasgal.2015-01-22_00.07.00_47 is waiting execution
114454 Increme auxeff.2015-01-22_00.07.00_48 is waiting execution
114455 Increme debinstall.2015-01-22_00.07.00_49 is waiting execution
114456 Increme efflog.2015-01-22_00.07.00_50 is waiting execution
114457 Increme effntp1.2015-01-22_00.07.00_51 is waiting execution
114458 Increme effntp2.2015-01-22_00.07.00_52 is waiting execution
114459 Increme effshare.2015-01-22_00.07.00_53 is waiting execution
114460 Increme elshare.2015-01-22_00.07.01_54 is waiting execution
114461 Increme fsef-mgt.2015-01-22_00.07.01_55 is waiting execution
114462 Increme fsef2-mgt.2015-01-22_00.07.01_56 is waiting execution
114463 Increme fsme-mgt.2015-01-22_00.07.01_57 is waiting execution
114464 Increme fsme1-mgt.2015-01-22_00.07.01_58 is waiting execution
114465 Increme fsme12-mgt.2015-01-22_00.07.01_59 is waiting execution
114466 Increme fsme2-mgt.2015-01-22_00.07.02_00 is waiting execution
114467 Increme fsother-mgt.2015-01-22_00.07.02_01 is waiting execution
114468 Increme fsother2-mgt.2015-01-22_00.07.02_02 is waiting execution
114469 Increme fsre-mgt.2015-01-22_00.07.02_03 is waiting execution
114470 Increme fsre2-mgt.2015-01-22_00.07.02_04 is waiting execution
114471 Increme fsrz-mgt.2015-01-22_00.07.02_05 is waiting execution
114472 Increme fsrz2-mgt.2015-01-22_00.07.02_06 is waiting execution
114473 Increme fswe-mgt.2015-01-22_00.07.02_07 is waiting execution
114474 Increme fswe2-mgt.2015-01-22_00.07.02_08 is waiting execution
114475 Increme fsze-mgt.2015-01-22_00.07.02_09 is waiting execution
114476 Increme fsze2-mgt.2015-01-22_00.07.02_10 is waiting execution
114477 Increme geosrv.2015-01-22_00.07.02_11 is waiting execution
114478 Increme gltfw.2015-01-22_00.07.02_12 is waiting execution
114479 Increme lcfs.2015-01-22_00.07.02_13 is waiting execution
114480 Increme log.2015-01-22_00.07.02_14 is waiting execution
114481 Increme mailbox1.2015-01-22_00.07.02_15 is waiting execution
114482 Increme mailbox2.2015-01-22_00.07.02_16 is waiting execution
114483 Increme mcn7.2015-01-22_00.07.02_17 is waiting execution
114484 Increme mcn8.2015-01-22_00.07.02_18 is waiting execution
114485 Increme miraculix.2015-01-22_00.07.02_19 is waiting execution
114486 Increme mmshare.2015-01-22_00.07.02_20 is waiting execution
114487 Increme nagios.2015-01-22_00.07.02_21 is waiting execution
114488 Increme ntp1.2015-01-22_00.07.02_22 is waiting execution
114489 Increme ntp2.2015-01-22_00.07.02_23 is waiting execution
114490 Increme numerix.2015-01-22_00.07.02_24 is waiting execution
114491 Increme observer3.2015-01-22_00.07.02_25 is waiting execution
114492 Increme observer4.2015-01-22_00.07.02_26 is waiting execution
114493 Increme observer6.2015-01-22_00.07.02_27 is waiting execution
114494 Increme owncloud.2015-01-22_00.07.02_28 is waiting execution
114495 Increme portal.2015-01-22_00.07.02_29 is waiting execution
114496 Increme portal2.2015-01-22_00.07.02_30 is waiting execution
114497 Increme project.2015-01-22_00.07.02_31 is waiting execution
114498 Increme psrfb7.2015-01-22_00.07.02_32 is waiting execution
114499 Increme publications.2015-01-22_00.07.02_33 is waiting execution
114500 Increme quasar.2015-01-22_00.07.02_34 is waiting execution
114501 Increme scishare.2015-01-22_00.07.02_35 is waiting execution
114502 Increme snort.2015-01-22_00.07.02_36 is waiting execution
114503 Increme snort2.2015-01-22_00.07.02_37 is waiting execution
114504 Increme swsrv1-mgt.2015-01-22_00.07.02_38 is waiting execution
114505 Increme swsrv1.2015-01-22_00.07.02_39 is waiting execution
114506 Increme swsrv12-mgt.2015-01-22_00.07.02_40 is waiting execution
114507 Increme tserver.2015-01-22_00.07.02_41 is waiting execution
114508 Increme vwshare.2015-01-22_00.07.02_42 is waiting execution
114509 Increme webdav.2015-01-22_00.07.02_43 is waiting execution
114510 Full BackupCatalog.2015-01-22_00.15.00_44 is waiting execution
114511 Increme backupsrv1.2015-01-22_00.15.00_45 is waiting execution
114512 SendDailyReport.2015-01-22_00.35.00_46 is waiting execution
====
Additional InformationConfig is attached
TagsNo tags attached.
bareos-master: impact
bareos-master: action
bareos-18.2: impact
bareos-18.2: action
bareos-17.2: impact
bareos-17.2: action
bareos-16.2: impact
bareos-16.2: action
bareos-15.2: impact
bareos-15.2: action
bareos-14.2: impact
bareos-14.2: action
bareos-13.2: impact
bareos-13.2: action
bareos-12.4: impact
bareos-12.4: action

Activities

jbehrend

jbehrend

2015-01-22 10:19

reporter  

bareos.config.tar.gz (34,261 bytes)
maik

maik

2015-11-06 17:51

administrator   ~0001944

Have you set AllowMixedPriority in restore job resource, too?
Does not look like a bug but more like a config isssue.
jbehrend

jbehrend

2015-11-06 18:23

reporter   ~0001950

Hello Maik,

in the formerly attached config you'll find: (so yes, it is configured)

# Standard Restore template, to be changed by Console program
Job {
   Name = "Restore"
   Type = Restore
   FileSet = "empty"
   Client = fsrz-fd
   Pool = fsrz-DailyPool
   Messages = Standard
   Where = /mnt/local
   AllowMixedPriority = yes
   Priority = 9
}
maik

maik

2015-11-06 18:41

administrator   ~0001951

I suggest to first reproduce this with a minimal configuration to mitigate side effects.
It's hard to try to analyse this remotely on a complex environment. This looks more like a support issue to me.
kjetilho

kjetilho

2017-02-14 12:37

reporter   ~0002563

The observed behaviour matches the documentation precisely. I'm the author of that patch, and I guess the bug is that I called the option "Allow Mixed Priority" instead of "Single Priority" (with default True to be backwards compatible).

I'm sure a patch to implement the desired behaviour would be accepted, although I have no good idea for what to call the new directive. Perhaps an additional value "Allow Mixed Priority = loose" or something? Or perhaps even just change the behaviour - I doubt anyone *really* relies on it. I certainly don't do myself.

Here's the documentation for reference:

''' Allow Mixed Priority = <yes|no>
    (default: no)
    When set to yes, this job may run even if lower priority jobs are already running. This means a high priority job will not have to wait for other jobs to finish before starting. The scheduler will only mix priorities when all running jobs have this set to true.

    Note that only higher priority jobs will start early. Suppose the director will allow two concurrent jobs, and that two jobs with priority 10 are running, with two more in the queue. If a job with priority 5 is added to the queue, it will be run as soon as one of the running jobs finishes. However, new priority 10 jobs will not be run until the priority 5 job has finished.
'''
arogge

arogge

2019-01-16 11:05

developer   ~0003183

As described the behaviour is as expected.
I'm closing this issue, but please feel free to write a feature request.

Issue History

Date Modified Username Field Change
2015-01-22 10:19 jbehrend New Issue
2015-01-22 10:19 jbehrend File Added: bareos.config.tar.gz
2015-01-26 19:31 mvwieringen Severity major => minor
2015-11-06 17:51 maik Note Added: 0001944
2015-11-06 17:51 maik Status new => closed
2015-11-06 17:51 maik Resolution open => unable to reproduce
2015-11-06 18:23 jbehrend Note Added: 0001950
2015-11-06 18:23 jbehrend Status closed => feedback
2015-11-06 18:23 jbehrend Resolution unable to reproduce => reopened
2015-11-06 18:41 maik Note Added: 0001951
2017-02-14 12:37 kjetilho Note Added: 0002563
2019-01-16 11:05 arogge Note Added: 0003183
2019-01-16 11:05 arogge Status feedback => resolved
2019-01-16 11:05 arogge Resolution reopened => no change required
2019-01-16 11:05 arogge Assigned To => arogge